package at.ac.uibk.gitsearch.service.dto;

import java.util.List;

public class SearchInputDTO {
    private String fulltextQuery;
    private SearchInputMetadataDTO metadata;
    private List<String> selectedRepository;
    private List<String> selectedUniversity;
    private List<String> selectedFileFormat;

    private int page;
	public static final int PAGE_SIZE = 10;

    public SearchInputDTO() {
    	// empty for jackson
    }
    public SearchInputDTO(String fulltextQuery, SearchInputMetadataDTO metadata,
                          List<String> selectedRepository, List<String> selectedUniversity,
                          List<String> selectedFileFormat, int page) {
        this.fulltextQuery = fulltextQuery;
        this.metadata = metadata;
        this.selectedRepository = selectedRepository;
        this.selectedUniversity = selectedUniversity;
        this.selectedFileFormat = selectedFileFormat;
        this.page = page;
    }

    public String getFulltextQuery() {
        return fulltextQuery;
    }

    public void setFulltextQuery(String fulltextQuery) {
        this.fulltextQuery = fulltextQuery;
    }

    public SearchInputMetadataDTO getMetadata() {
        return metadata;
    }

    public void setMetadata(SearchInputMetadataDTO metadata){
        this.metadata = metadata;
    }

    public List<String> getSelectedRepository() {
        return selectedRepository;
    }

    public void setSelectedRepository(List<String> selectedRepository) {
        this.selectedRepository = selectedRepository;
    }

    public List<String> getSelectedUniversity() {
        return selectedUniversity;
    }

    public void setSelectedUniversity(List<String> selectedUniversity) {
        this.selectedUniversity = selectedUniversity;
    }

    public List<String> getSelectedFileFormat() {
        return selectedFileFormat;
    }

    public void setSelectedFileFormat(List<String> selectedFileFormat) {
        this.selectedFileFormat = selectedFileFormat;
    }

    public int getPage() {
        return page;
    }

    public void setPage(int page) {
        this.page = page;
    }

    public boolean hasMetadataInput() {
        return this.metadata.hasMetadataInput();
    }

    @Override
	public String toString() {
		return "SearchInputDTO [fulltextQuery=" + fulltextQuery + ", selectedRepository=" + selectedRepository + ", selectedUniversity="
				+ selectedUniversity + ", selectedFileFormat=" + selectedFileFormat + ", page=" + page + ", metadata: {" + metadata + "}]";
	}


}
