package at.ac.uibk.gitsearch.service.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Arrays;
import java.util.Objects;

public class UserProvidedMetadataDTO {

    public UserProvidedMetadataDTO() {
        // default constructor
    }

    private String metadataVersion; // just for YAML test data reader
    private String title;
    private String identifier;
    private String version;
    private String structure;

    private String description;
    private ExerciseType type;
    private String license;
    private String[] keyword;

    private String[] format;
    private String[] programmingLanguage;
    private String[] language;
    private String status;

    private String educationLevel;

    @JsonIgnore
    private String audience;

    private String timeRequired;

    @JsonIgnore
    private String[] collectionContent;

    private Person[] creator;
    private Person[] publisher;
    private Person[] contributor;

    private boolean deprecated;

    private String difficulty;
    private String[] source;

    private String[] requires;
    private String image;

    public String getIdentifier() {
        return identifier;
    }

    public void setIdentifier(String identifier) {
        this.identifier = identifier;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public ExerciseType getType() {
        return type;
    }

    public void setType(ExerciseType type) {
        this.type = type;
    }

    public String[] getLanguage() {
        return language;
    }

    public void setLanguage(String[] language) {
        this.language = language;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getEducationLevel() {
        return educationLevel;
    }

    public void setEducationLevel(String educationLevel) {
        this.educationLevel = educationLevel;
    }

    public String getAudience() {
        return audience;
    }

    public void setAudience(String audience) {
        this.audience = audience;
    }

    public String getTimeRequired() {
        return timeRequired;
    }

    public void setTimeRequired(String timeRequired) {
        this.timeRequired = timeRequired;
    }

    public Person[] getCreator() {
        return creator;
    }

    public void setCreator(Person[] creator) {
        this.creator = creator;
    }

    public Person[] getPublisher() {
        return publisher;
    }

    public void setPublisher(Person[] publisher) {
        this.publisher = publisher;
    }

    public Person[] getContributor() {
        return contributor;
    }

    public void setContributor(Person[] contributor) {
        this.contributor = contributor;
    }

    public boolean isDeprecated() {
        return deprecated;
    }

    public void setDeprecated(boolean deprecated) {
        this.deprecated = deprecated;
    }

    public String getDifficulty() {
        return difficulty;
    }

    public void setDifficulty(String difficulty) {
        this.difficulty = difficulty;
    }

    public String[] getSource() {
        return source;
    }

    public void setSource(String[] source) {
        this.source = source;
    }

    public String[] getRequires() {
        return requires;
    }

    public void setRequires(String[] requires) {
        this.requires = requires;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    private String repositoryURL;

    public String getMetadataVersion() {
        return metadataVersion;
    }

    public void setMetadataVersion(String metadataVersion) {
        this.metadataVersion = metadataVersion;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getLicense() {
        return license;
    }

    public void setLicense(String license) {
        this.license = license;
    }

    public String[] getKeyword() {
        return keyword;
    }

    public void setKeyword(String[] keyword) {
        this.keyword = keyword;
    }

    public String[] getFormat() {
        return format;
    }

    public void setFormat(String[] format) {
        this.format = format;
    }

    public String[] getProgrammingLanguage() {
        return programmingLanguage;
    }

    public void setProgrammingLanguage(String[] programmingLanguage) {
        this.programmingLanguage = programmingLanguage;
    }

    public String getRepositoryURL() {
        return repositoryURL;
    }

    public void setRepositoryURL(String repositoryURL) {
        this.repositoryURL = repositoryURL;
    }

    public String getStructure() {
        return structure;
    }

    public void setStructure(String structure) {
        this.structure = structure;
    }

    /**
     * clone constructor
     *
     * @param toClone
     */
    public UserProvidedMetadataDTO(UserProvidedMetadataDTO toClone) {
        super();
        this.metadataVersion = toClone.metadataVersion;
        this.title = toClone.title;
        this.identifier = toClone.identifier;
        this.version = toClone.version;
        this.structure = toClone.structure;
        this.description = toClone.description;
        this.type = toClone.type;
        this.license = toClone.license;
        this.keyword = toClone.keyword;
        this.format = toClone.format;
        this.programmingLanguage = toClone.programmingLanguage;
        this.language = toClone.language;
        this.status = toClone.status;
        this.educationLevel = toClone.educationLevel;
        this.audience = toClone.audience;
        this.timeRequired = toClone.timeRequired;
        this.collectionContent = toClone.collectionContent;
        this.creator = toClone.creator;
        this.publisher = toClone.publisher;
        this.contributor = toClone.contributor;
        this.deprecated = toClone.deprecated;
        this.difficulty = toClone.difficulty;
        this.source = toClone.source;
        this.requires = toClone.requires;
        this.image = toClone.image;
        this.repositoryURL = toClone.repositoryURL;
    }

    @Override
    public String toString() {
        return "UserProvidedMetadataDTO { audience: " + audience
            + ", collectionContent: " + Arrays.toString(collectionContent)
            + ", contributor: " + Arrays.toString(contributor)
            + ", creator: " + Arrays.toString(creator)
            + ", deprecated: " + deprecated
            + ", description: " + description
            + ", difficulty: " + difficulty
            + ", educationLevel: " + educationLevel
            + ", format: " + Arrays.toString(format)
            + ", identifier:" + identifier
            + ", image: " + image
            + ", keyword: " + Arrays.toString(keyword)
            + ", language: " + Arrays.toString(language)
            + ", license: " + license
            + ", metadataVersion: " + metadataVersion
            + ", programmingLanguage: " + Arrays.toString(programmingLanguage)
            + ", publisher: " + Arrays.toString(publisher)
            + ", repositoryURL: " + repositoryURL
            + ", requires: " + Arrays.toString(requires)
            + ", source: " + Arrays.toString(source)
            + ", status: " + status
            + ", structure: " + structure
            + ", timeRequired: " + timeRequired
            + ", title: " + title
            + ", type: " + type
            + ", version: " + version
            + " }";
    }

    @Override
    public final int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((audience == null) ? 0 : audience.hashCode());
        result = prime * result + Arrays.hashCode(collectionContent);
        result = prime * result + Arrays.hashCode(contributor);
        result = prime * result + Arrays.hashCode(creator);
        result = prime * result + (deprecated ? 1231 : 1237);
        result = prime * result + ((description == null) ? 0 : description.hashCode());
        result = prime * result + ((difficulty == null) ? 0 : difficulty.hashCode());
        result = prime * result + ((educationLevel == null) ? 0 : educationLevel.hashCode());
        result = prime * result + Arrays.hashCode(format);
        result = prime * result + ((identifier == null) ? 0 : identifier.hashCode());
        result = prime * result + ((image == null) ? 0 : image.hashCode());
        result = prime * result + Arrays.hashCode(keyword);
        result = prime * result + Arrays.hashCode(language);
        result = prime * result + ((license == null) ? 0 : license.hashCode());
        result = prime * result + ((metadataVersion == null) ? 0 : metadataVersion.hashCode());
        result = prime * result + Arrays.hashCode(programmingLanguage);
        result = prime * result + Arrays.hashCode(publisher);
        result = prime * result + ((repositoryURL == null) ? 0 : repositoryURL.hashCode());
        result = prime * result + Arrays.hashCode(requires);
        result = prime * result + Arrays.hashCode(source);
        result = prime * result + ((status == null) ? 0 : status.hashCode());
        result = prime * result + ((structure == null) ? 0 : structure.hashCode());
        result = prime * result + ((timeRequired == null) ? 0 : timeRequired.hashCode());
        result = prime * result + ((title == null) ? 0 : title.hashCode());
        result = prime * result + ((type == null) ? 0 : type.hashCode());
        result = prime * result + ((version == null) ? 0 : version.hashCode());
        return result;
    }

    @Override
    public final boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!(obj instanceof UserProvidedMetadataDTO)) {
            return false;
        }
        UserProvidedMetadataDTO other = (UserProvidedMetadataDTO) obj;
        return Objects.equals(this.audience, other.audience)
            && Arrays.equals(this.collectionContent, other.collectionContent)
            && Arrays.equals(this.contributor, other.contributor)
            && Arrays.equals(this.creator, other.creator)
            && this.deprecated == other.deprecated
            && Objects.equals(this.description, other.description)
            && Objects.equals(this.difficulty, other.difficulty)
            && Objects.equals(this.educationLevel, other.educationLevel)
            && Arrays.equals(this.format, other.format)
            && Objects.equals(this.identifier, other.identifier)
            && Objects.equals(this.image, other.image)
            && Arrays.equals(this.keyword, other.keyword)
            && Arrays.equals(this.language, other.language)
            && Objects.equals(this.license, other.license)
            && Objects.equals(this.metadataVersion, other.metadataVersion)
            && Arrays.equals(this.programmingLanguage, other.programmingLanguage)
            && Arrays.equals(this.publisher, other.publisher)
            && Objects.equals(this.repositoryURL, other.repositoryURL)
            && Arrays.equals(this.requires, other.requires)
            && Arrays.equals(this.source, other.source)
            && Objects.equals(this.status, other.status)
            && Objects.equals(this.structure, other.structure)
            && Objects.equals(this.timeRequired, other.timeRequired)
            && Objects.equals(this.title, other.title)
            && this.type == other.type
            && Objects.equals(this.version, other.version);
    }


    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ExerciseType {
        PROGRAMMING_EXERCISE("programming exercise"), EXERCISE("exercise"), COLLECTION("collection"), OTHER("other");

        ExerciseType(String externalName) {
            this.externalName = externalName;
        }

        private final String externalName;

        @JsonValue
        public String getExternalName() {
            return externalName;
        }
    }

    public static class Person {
        private String name;
        private String affiliation;
        private String email;

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getAffiliation() {
            return affiliation;
        }

        public void setAffiliation(String affiliation) {
            this.affiliation = affiliation;
        }

        public String getEmail() {
            return email;
        }

        public void setEmail(String email) {
            this.email = email;
        }

        @Override
        public String toString() {
            return "Person: { name: " + this.name
                + ", affiliation: " + this.affiliation
                + ", email: " + this.email
                + " }";
        }

        @Override
        public final int hashCode() {
            final int prime = 31;
            int result = 1;
            result = prime * result + ((affiliation == null) ? 0 : affiliation.hashCode());
            result = prime * result + ((email == null) ? 0 : email.hashCode());
            result = prime * result + ((name == null) ? 0 : name.hashCode());
            return result;
        }

        @Override
        public final boolean equals(Object obj) {
            if (this == obj) {
                return true;
            }
            if (!(obj instanceof Person)) {
                return false;
            }
            Person other = (Person) obj;
            return Objects.equals(this.affiliation, other.affiliation)
                && Objects.equals(this.email, other.email)
                && Objects.equals(this.name, other.name);
        }
    }
}

